#    Back In Time
#    Copyright (C) 2008-2009 Oprea Dan, Bart de Koning, Richard Bailey
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

import os
import signal

def get_subprocess_list(allparents,pidlist,pid):
        if pid in allparents:
                #print 'In loop pid ' + pid + ' has children %s '  % allparents[pid]
                for child_pid in allparents[pid]:
                        pidlist.append(child_pid)
                        #print 'In loop recursively getting children of child %s' % child_pid
                        get_subprocess_list(allparents,pidlist,child_pid)
	#else:
	#	print 'In loop pid %s has no children' % pid
        return pidlist

def pause_subprocesses(pid):
        return signal_subprocesses(pid,signal.SIGSTOP)

def continue_subprocesses(pid):
        return signal_subprocesses(pid,signal.SIGCONT)

def terminate_subprocesses(pid):
        return signal_subprocesses(pid,signal.SIGKILL)

def signal_subprocesses(pid,sig):
        cmd = "ps eo pid,ppid"
        allparents={}
        pidlist=[]

	#print 'Running ps to get parent/child relationships'
        pscmd = os.popen(cmd).readlines()
        for ps in pscmd[1:]:
                child,parent=ps.split()
                if parent in allparents:
                        allparents[parent].append(child)
                else:
                        allparents[parent] = [child]

	#print 'Checking pid %s for subprocesses' % pid
        pidlist = get_subprocess_list(allparents,pidlist,pid)
        #print 'PID %s has subprocesses: %s ' % (pid,pidlist)

        for apid in pidlist:
                #print 'Signalling pid %s with signal %s' % ( apid, sig )
		try:
	                os.kill(int(apid),sig)
		except:
			pass
	return pidlist

